/*-
 * type.h - type definitions
 *
 * Copyright (c) 1992, 1996
 *	Department of Mathematical and Computing Sciences,
 *	Tokyo Institute of Technology.  All rights reserved.
 *
 * $Id: type.h,v 2.6 1996/05/12 06:46:47 ushijima Exp $
 */

#include <stdio.h>

typedef int elt;		/* unknown type (but 4byte) */
typedef int object;		/* generic object */

/* Built-in Types and Type Generators */

#include <clu2c/bool.h>
#include <clu2c/null.h>
#include <clu2c/int.h>
#include <clu2c/real.h>
#include <clu2c/char.h>
#include <clu2c/string.h>
#include <clu2c/array.h>
#include <clu2c/sequence.h>
#include <clu2c/record.h>
#include <clu2c/struct.h>
#include <clu2c/oneof.h>
#include <clu2c/variant.h>
#include <clu2c/proctype.h>
#include <clu2c/itertype.h>
#include <clu2c/any.h>

/* Other Standard Libraries */

#include <clu2c/fname.h>
#include <clu2c/istream.h>
#include <clu2c/wvec.h>

/* Used by the system */

typedef elt cvt;
typedef elt clus;		/* user-defined cluster */
typedef elt generic;
typedef char *type_parm;	/* type parameter name */
typedef proctype oplist_t[];	/* operation list */
typedef struct {
    proctype *oplist;		/* parameter-specific routines */
    int local_own_id;		/* ID of routine own variables */
    int clus_own_id;		/* ID of cluster own variables */
    elt *vparms;		/* value parameters */
} param_info;
