/*
 * null.c - implementation of null
 *
 * Copyright (c) 1992, 1996
 *	Department of Mathematical and Computing Sciences,
 *	Tokyo Institute of Technology.  All rights reserved.
 *
 * $Id: null.c,v 2.6 1996/05/12 06:37:11 ushijima Exp $
 */

#include <clu2c/clu2c.h>
#include <clu2c/type.h>
#include <clu2c/glo.h>


/*
 * Operations
 */


/*
 * equal = proc(n1, n2: null) returns(bool)
 */

int OFnull_Dequal(n1, n2)
null n1;
null n2;
{
    RETURN1(OMnull_Dequal(n1, n2));
}


/*
 * similar = proc(n1, n2: null) returns(null)
 */

int OFnull_Dsimilar(n1, n2)
null n1;
null n2;
{
    RETURN1(OMnull_Dsimilar(n1, n2));
}


/*
 * copy = proc(n: null) returns(null)
 */

int OFnull_Dcopy(n)
null n;
{
    RETURN1(OMnull_Dcopy(n));
}


/*
 * print = proc(n: null, pst: pstream) 
 */

int OFnull_Dprint(n, pst)
null n;
object pst;			/* pstream */
{
    static string nil = NULL;

    if (nil == NULL) {
	nil = OFstring_D__cs2s("nil");
    }

    if (OFpstream_Dtext(pst, nil) == SIG) {
	out_handler();
	return(SIG);
    }
    RETURN0;
}


/*
 * encode = proc(n: null, ist: istream) signals(not_possible(string))
 */

int OFnull_Dencode(n, ist)
null n;
object ist;			/* istream */
{
    return OFistream_Dputi(ist, NIL);
}


/*
 * decode = proc(ist: istream) returns(null)
 *          signals(end_of_file, not_possible(string))
 */

int OFnull_Ddecode(ist)
object ist;			/* istream */
{
    if (OFistream_Dgeti(ist) == SIG) {
	return SIG;
    }
    if (retval_area[0] != NIL) {
	SIGNAL1(SLNOT_POSSIBLE, OFstring_D__cs2s("bad format"));
    }
    return RET;
}


/*
 * _gcd = proc(n: null, tab: gcd_tab) returns(int)
 */

int OFnull_D__gcd(n, tab)
null n;
object tab;			/* gcd_tab */
{
    /* stub version */
    SIGNAL1(SLFAILURE, OFstring_D__cs2s("null$_gcd: not implemented"));
}
